#include "Header.h"

void createFileWinApi(char* path)
{
	HANDLE FileTask;//  

	FileTask = CreateFileA(// 
		path, //
		GENERIC_READ | GENERIC_WRITE | GENERIC_ALL,//    
		FILE_SHARE_WRITE | FILE_SHARE_READ,//     
		NULL,//
		CREATE_ALWAYS,// -    
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,// 
		0);// 

	if (GetLastError() == 2)
	{
		printf("   \n");//   
		exit(1);// 
	}

	CloseHandle(FileTask);
}

void deleteFileWinApi(char* path)
{
	if (GetFileAttributesA(path) != -1)//  , ..   GetFileAttributesA != INVALID_FILE_ATTRIBUTES
	{
		DeleteFileA(path);// 
	}
}

void writeWinApi(char* path, char* str)
{
	deleteFileWinApi(path); //     
	createFileWinApi(path); //  

	HANDLE FileTask;//  

	FileTask = CreateFileA(// 
		path, //
		GENERIC_READ | GENERIC_WRITE | GENERIC_ALL,//    
		FILE_SHARE_WRITE | FILE_SHARE_READ,//     
		NULL,//
		CREATE_NEW,// -    
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,// 
		0);// 

	if (GetLastError() == 2)
	{
		printf("   \n");//   
		exit(1);// 
	}

	char* info_buf = calloc(1000, sizeof(char));
	char* buffer = calloc(strlen(str)+1,sizeof(char)); //    

	FileTask = OpenFile(// 
		path,//  
		info_buf,//  
		OF_WRITE | OF_READWRITE);//     

	if (GetLastError() == -1)
	{
		printf("  ");
		exit(1);
	}

	WriteFile(//    
		FileTask,//
		str,//
		strlen(str),//
		NULL,// 
		NULL);// 

	if (GetLastError() == 6)//ERROR_INVALID_HANDLE -  
	{
		printf("O   \n");
		exit(6);
	}

	CloseHandle(FileTask);// 
}

char* readWinApi(char* path)
{
	HANDLE FileTask;//  

	FileTask = CreateFile(// 
		path, //
		GENERIC_READ | GENERIC_WRITE | GENERIC_ALL,//    
		FILE_SHARE_WRITE | FILE_SHARE_READ,//     
		NULL,//
		OPEN_EXISTING | OPEN_ALWAYS,// -    
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,// 
		0);// 

	if (GetLastError() == 2)
	{
		printf("   \n");//   
		exit(1);// 
	}

	char* info_buf = calloc(1000, sizeof(char));
	char* buffer = calloc(1000, sizeof(char)); //    

	FileTask = OpenFile(// 
		path,//  
		info_buf,//  
		OF_READ);//       

	if (GetLastError() == -1)
	{
		printf("  ");
		exit(1);
	}

	ReadFile(//  
		FileTask,//  
		buffer,//  
		1000,//     
		NULL,//   
		NULL);//   

	if (GetLastError() == 1784 || GetLastError() == 6)
	{
		printf("  ");
		exit(5);
	}

	CloseHandle(FileTask);// 

	return buffer;
}

void withWinApi()
{
	char* thisPath = PATH2;
	char* thisAnswer = ANSWERTASK2;

	deleteFileWinApi(thisAnswer);//   ,        

	printf("\n  :");
	char* str = calloc(1000, sizeof(char));
	gets(str);
	
	writeWinApi(thisPath, str);
	char* buffer = readWinApi(thisPath);

	// 
	float a;
	float b;
	float c;

	int CODE_PARAM = sscanf(buffer, "%f%f%f", &a, &b, &c);// 
	countArg(CODE_PARAM);

	float Discriminant = b * b - 4 * c * a;// 

 	char* answer = calloc(1000, sizeof(char));

	if (Discriminant < 0)//  
	{
		printf("  0.  \n");//   
		sprintf(answer, "%s %5.3f %s %5.3f %s %5.3f %s %5.3f", "  (", a, ")*x^2 + (", b, ")*x + (", c, ") = 0\n  ,     = ", Discriminant);// 
		writeWinApi(thisAnswer, answer);
		exit(3);// 
	}

	//    
	if (a == 0)
	{
		printf("   0\n");
		sprintf(answer, "%s %5.3f %s %5.3f %s %5.3f %s", "  (", a, ")*x^2 + (", b, ")*x + (", c, ") = 0\n    0");// 
		writeWinApi(thisAnswer, answer);
		exit(4);
	}

	//  
	if (Discriminant == 0)
	{
		float x = -b / (2 * a);//  
		sprintf(answer, "%s %5.3f %s %5.3f %s %5.3f %s %5.3f %s %5.3f", "  (", a, ")*x^2 + (", b, ")*x + (", c, ") = 0  1  \nx = ", x, "\n = ", Discriminant);// 
		writeWinApi(thisAnswer, answer);
		printf("  (%5.3f)*x^2 + (%5.3f)*x + (%5.3f) = 0  1  \nx = %5.3f\n = %5.3f\n", a, b, c, x, Discriminant);
	}
	else
	{
		//  
		float x1 = (-b + sqrt(Discriminant)) / (2 * a);
		float x2 = (-b - sqrt(Discriminant)) / (2 * a);
		sprintf(answer, "%s %5.3f %s %5.3f %s %5.3f %s %5.3f %s %5.3f %s %5.3f", "  (", a, ")*x^2 + (", b, ")*x + (", c, ") = 0  2  \nx1 = ", x1, ", x2 = ", x2, "\n = ", Discriminant);// 
		writeWinApi(thisAnswer, answer);
		printf("  (%5.3f)*x^2 + (%5.3f)*x + (%5.3f) = 0  2  \nx1 = %5.3f, x2 = %5.3f\n = %5.3f\n", a, b, c, x1, x2, Discriminant);
	}
}